## shim 15+1533136590.3beb971

=== Cryptlib/OpenSSL/Makefile ===

EFI_INCLUDES	= -I$(TOPDIR)/../Include \
		  -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol \
		  -I$(TOPDIR)/crypto/asn1 -I$(TOPDIR)/crypto/evp -I$(TOPDIR)/crypto/modes -I$(TOPDIR)/crypto/include

CFLAGS		= -ggdb -O0 -I$(TOPDIR) -I$(TOPDIR)/.. -I$(TOPDIR)/../Include/ -I$(TOPDIR)/crypto \
		  -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar -nostdinc \
		  -ffreestanding -std=gnu89 -I$(shell $(CC) -print-file-name=include) \
		  -Wall $(EFI_INCLUDES) -DL_ENDIAN -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DNO_SYSLOG -DOPENSSL_SMALL_FOOTPRINT -DPEDANTIC

CLANG_BUGS	= $(if $(findstring gcc,$(CC)),-maccumulate-outgoing-args,)

ifeq ($(ARCH),x86_64)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone $(CLANG_BUGS) \
		-m64 -DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI \
		-UNO_BUILTIN_VA_FUNCS -DMDE_CPU_X64
endif
ifeq ($(ARCH),ia32)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc \
		$(CLANG_BUGS) -m32 -DMDE_CPU_IA32
endif
ifeq ($(ARCH),aarch64)
	CFLAGS	+= -O2 -DMDE_CPU_AARCH64
endif
ifeq ($(ARCH),arm)
	CFLAGS	+= -O2 -DMDE_CPU_ARM
endif
LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libopenssl.a
OBJS		= crypto/bio/b_print.o \
		  crypto/aes/aes_cbc.o \
		  crypto/aes/aes_cfb.o \
		  crypto/aes/aes_core.o \
		  crypto/aes/aes_ecb.o \
		  crypto/aes/aes_ige.o \
		  crypto/aes/aes_misc.o \
		  crypto/aes/aes_ofb.o \
		  crypto/aes/aes_wrap.o \
		  crypto/asn1/a_bitstr.o \
		  crypto/asn1/a_d2i_fp.o \
		  crypto/asn1/a_digest.o \
		  crypto/asn1/a_dup.o \
		  crypto/asn1/a_gentm.o \
		  crypto/asn1/a_i2d_fp.o \
		  crypto/asn1/a_int.o \
		  crypto/asn1/a_mbstr.o \
		  crypto/asn1/a_object.o \
		  crypto/asn1/a_octet.o \
		  crypto/asn1/a_print.o \
		  crypto/asn1/a_sign.o \
		  crypto/asn1/a_strex.o \
		  crypto/asn1/a_strnid.o \
		  crypto/asn1/a_time.o \
		  crypto/asn1/a_type.o \
		  crypto/asn1/a_utctm.o \
		  crypto/asn1/a_utf8.o \
		  crypto/asn1/a_verify.o \
		  crypto/asn1/ameth_lib.o \
		  crypto/asn1/asn1_err.o \
		  crypto/asn1/asn1_gen.o \
		  crypto/asn1/asn1_lib.o \
		  crypto/asn1/asn1_par.o \
		  crypto/asn1/asn_mime.o \
		  crypto/asn1/asn_moid.o \
		  crypto/asn1/asn_mstbl.o \
		  crypto/asn1/asn_pack.o \
		  crypto/asn1/bio_asn1.o \
		  crypto/asn1/bio_ndef.o \
		  crypto/asn1/d2i_pr.o \
		  crypto/asn1/d2i_pu.o \
		  crypto/asn1/evp_asn1.o \
		  crypto/asn1/f_int.o \
		  crypto/asn1/f_string.o \
		  crypto/asn1/i2d_pr.o \
		  crypto/asn1/i2d_pu.o \
		  crypto/asn1/n_pkey.o \
		  crypto/asn1/nsseq.o \
		  crypto/asn1/p5_pbe.o \
		  crypto/asn1/p5_pbev2.o \
		  crypto/asn1/p5_scrypt.o \
		  crypto/asn1/p8_pkey.o \
		  crypto/asn1/t_bitst.o \
		  crypto/asn1/t_pkey.o \
		  crypto/asn1/t_spki.o \
		  crypto/asn1/tasn_dec.o \
		  crypto/asn1/tasn_enc.o \
		  crypto/asn1/tasn_fre.o \
		  crypto/asn1/tasn_new.o \
		  crypto/asn1/tasn_prn.o \
		  crypto/asn1/tasn_scn.o \
		  crypto/asn1/tasn_typ.o \
		  crypto/asn1/tasn_utl.o \
		  crypto/asn1/x_algor.o \
		  crypto/asn1/x_bignum.o \
		  crypto/asn1/x_info.o \
		  crypto/asn1/x_long.o \
		  crypto/asn1/x_pkey.o \
		  crypto/asn1/x_sig.o \
		  crypto/asn1/x_spki.o \
		  crypto/asn1/x_val.o \
		  crypto/async/arch/async_null.o \
		  crypto/async/arch/async_posix.o \
		  crypto/async/arch/async_win.o \
		  crypto/async/async.o \
		  crypto/async/async_err.o \
		  crypto/async/async_wait.o \
		  crypto/bio/b_addr.o \
		  crypto/bio/b_dump.o \
		  crypto/bio/b_sock.o \
		  crypto/bio/b_sock2.o \
		  crypto/bio/bf_buff.o \
		  crypto/bio/bf_lbuf.o \
		  crypto/bio/bf_nbio.o \
		  crypto/bio/bf_null.o \
		  crypto/bio/bio_cb.o \
		  crypto/bio/bio_err.o \
		  crypto/bio/bio_lib.o \
		  crypto/bio/bio_meth.o \
		  crypto/bio/bss_acpt.o \
		  crypto/bio/bss_bio.o \
		  crypto/bio/bss_conn.o \
		  crypto/bio/bss_dgram.o \
		  crypto/bio/bss_fd.o \
		  crypto/bio/bss_file.o \
		  crypto/bio/bss_log.o \
		  crypto/bio/bss_mem.o \
		  crypto/bio/bss_null.o \
		  crypto/bio/bss_sock.o \
		  crypto/bn/bn_add.o \
		  crypto/bn/bn_asm.o \
		  crypto/bn/bn_blind.o \
		  crypto/bn/bn_const.o \
		  crypto/bn/bn_ctx.o \
		  crypto/bn/bn_depr.o \
		  crypto/bn/bn_dh.o \
		  crypto/bn/bn_div.o \
		  crypto/bn/bn_err.o \
		  crypto/bn/bn_exp.o \
		  crypto/bn/bn_exp2.o \
		  crypto/bn/bn_gcd.o \
		  crypto/bn/bn_gf2m.o \
		  crypto/bn/bn_intern.o \
		  crypto/bn/bn_kron.o \
		  crypto/bn/bn_lib.o \
		  crypto/bn/bn_mod.o \
		  crypto/bn/bn_mont.o \
		  crypto/bn/bn_mpi.o \
		  crypto/bn/bn_mul.o \
		  crypto/bn/bn_nist.o \
		  crypto/bn/bn_prime.o \
		  crypto/bn/bn_print.o \
		  crypto/bn/bn_rand.o \
		  crypto/bn/bn_recp.o \
		  crypto/bn/bn_shift.o \
		  crypto/bn/bn_sqr.o \
		  crypto/bn/bn_sqrt.o \
		  crypto/bn/bn_srp.o \
		  crypto/bn/bn_word.o \
		  crypto/bn/bn_x931p.o \
		  crypto/buffer/buf_err.o \
		  crypto/buffer/buffer.o \
		  crypto/cmac/cm_ameth.o \
		  crypto/cmac/cm_pmeth.o \
		  crypto/cmac/cmac.o \
		  crypto/comp/c_zlib.o \
		  crypto/comp/comp_err.o \
		  crypto/comp/comp_lib.o \
		  crypto/conf/conf_api.o \
		  crypto/conf/conf_def.o \
		  crypto/conf/conf_err.o \
		  crypto/conf/conf_lib.o \
		  crypto/conf/conf_mall.o \
		  crypto/conf/conf_mod.o \
		  crypto/conf/conf_sap.o \
		  crypto/cpt_err.o \
		  crypto/cryptlib.o \
		  crypto/cversion.o \
		  crypto/dh/dh_ameth.o \
		  crypto/dh/dh_asn1.o \
		  crypto/dh/dh_check.o \
		  crypto/dh/dh_depr.o \
		  crypto/dh/dh_err.o \
		  crypto/dh/dh_gen.o \
		  crypto/dh/dh_kdf.o \
		  crypto/dh/dh_key.o \
		  crypto/dh/dh_lib.o \
		  crypto/dh/dh_meth.o \
		  crypto/dh/dh_pmeth.o \
		  crypto/dh/dh_prn.o \
		  crypto/dh/dh_rfc5114.o \
		  crypto/dso/dso_dl.o \
		  crypto/dso/dso_dlfcn.o \
		  crypto/dso/dso_err.o \
		  crypto/dso/dso_lib.o \
		  crypto/dso/dso_openssl.o \
		  crypto/dso/dso_vms.o \
		  crypto/dso/dso_win32.o \
		  crypto/ebcdic.o \
		  crypto/err/err.o \
		  crypto/err/err_all.o \
		  crypto/err/err_prn.o \
		  crypto/evp/bio_b64.o \
		  crypto/evp/bio_enc.o \
		  crypto/evp/bio_md.o \
		  crypto/evp/bio_ok.o \
		  crypto/evp/c_allc.o \
		  crypto/evp/c_alld.o \
		  crypto/evp/cmeth_lib.o \
		  crypto/evp/digest.o \
		  crypto/evp/e_aes.o \
		  crypto/evp/e_aes_cbc_hmac_sha1.o \
		  crypto/evp/e_aes_cbc_hmac_sha256.o \
		  crypto/evp/e_bf.o \
		  crypto/evp/e_camellia.o \
		  crypto/evp/e_cast.o \
		  crypto/evp/e_chacha20_poly1305.o \
		  crypto/evp/e_des.o \
		  crypto/evp/e_des3.o \
		  crypto/evp/e_idea.o \
		  crypto/evp/e_null.o \
		  crypto/evp/e_old.o \
		  crypto/evp/e_rc2.o \
		  crypto/evp/e_rc4.o \
		  crypto/evp/e_rc4_hmac_md5.o \
		  crypto/evp/e_rc5.o \
		  crypto/evp/e_seed.o \
		  crypto/evp/e_xcbc_d.o \
		  crypto/evp/encode.o \
		  crypto/evp/evp_cnf.o \
		  crypto/evp/evp_enc.o \
		  crypto/evp/evp_err.o \
		  crypto/evp/evp_key.o \
		  crypto/evp/evp_lib.o \
		  crypto/evp/evp_pbe.o \
		  crypto/evp/evp_pkey.o \
		  crypto/evp/m_md2.o \
		  crypto/evp/m_md4.o \
		  crypto/evp/m_md5.o \
		  crypto/evp/m_md5_sha1.o \
		  crypto/evp/m_mdc2.o \
		  crypto/evp/m_null.o \
		  crypto/evp/m_ripemd.o \
		  crypto/evp/m_sha1.o \
		  crypto/evp/m_sigver.o \
		  crypto/evp/m_wp.o \
		  crypto/evp/names.o \
		  crypto/evp/p5_crpt.o \
		  crypto/evp/p5_crpt2.o \
		  crypto/evp/p_dec.o \
		  crypto/evp/p_enc.o \
		  crypto/evp/p_lib.o \
		  crypto/evp/p_open.o \
		  crypto/evp/p_seal.o \
		  crypto/evp/p_sign.o \
		  crypto/evp/p_verify.o \
		  crypto/evp/pmeth_fn.o \
		  crypto/evp/pmeth_gn.o \
		  crypto/evp/pmeth_lib.o \
		  crypto/evp/scrypt.o \
		  crypto/ex_data.o \
		  crypto/hmac/hm_ameth.o \
		  crypto/hmac/hm_pmeth.o \
		  crypto/hmac/hmac.o \
		  crypto/init.o \
		  crypto/kdf/hkdf.o \
		  crypto/kdf/kdf_err.o \
		  crypto/kdf/tls1_prf.o \
		  crypto/lhash/lh_stats.o \
		  crypto/lhash/lhash.o \
		  crypto/md5/md5_dgst.o \
		  crypto/md5/md5_one.o \
		  crypto/mem.o \
		  crypto/mem_clr.o \
		  crypto/mem_dbg.o \
		  crypto/mem_sec.o \
		  crypto/modes/cbc128.o \
		  crypto/modes/ccm128.o \
		  crypto/modes/cfb128.o \
		  crypto/modes/ctr128.o \
		  crypto/modes/cts128.o \
		  crypto/modes/gcm128.o \
		  crypto/modes/ocb128.o \
		  crypto/modes/ofb128.o \
		  crypto/modes/wrap128.o \
		  crypto/modes/xts128.o \
		  crypto/o_dir.o \
		  crypto/o_fips.o \
		  crypto/o_fopen.o \
		  crypto/o_init.o \
		  crypto/o_str.o \
		  crypto/o_time.o \
		  crypto/objects/o_names.o \
		  crypto/objects/obj_dat.o \
		  crypto/objects/obj_err.o \
		  crypto/objects/obj_lib.o \
		  crypto/objects/obj_xref.o \
		  crypto/ocsp/ocsp_asn.o \
		  crypto/ocsp/ocsp_cl.o \
		  crypto/ocsp/ocsp_err.o \
		  crypto/ocsp/ocsp_ext.o \
		  crypto/ocsp/ocsp_ht.o \
		  crypto/ocsp/ocsp_lib.o \
		  crypto/ocsp/ocsp_prn.o \
		  crypto/ocsp/ocsp_srv.o \
		  crypto/ocsp/ocsp_vfy.o \
		  crypto/ocsp/v3_ocsp.o \
		  crypto/pem/pem_all.o \
		  crypto/pem/pem_err.o \
		  crypto/pem/pem_info.o \
		  crypto/pem/pem_lib.o \
		  crypto/pem/pem_oth.o \
		  crypto/pem/pem_pk8.o \
		  crypto/pem/pem_pkey.o \
		  crypto/pem/pem_sign.o \
		  crypto/pem/pem_x509.o \
		  crypto/pem/pem_xaux.o \
		  crypto/pem/pvkfmt.o \
		  crypto/pkcs12/p12_add.o \
		  crypto/pkcs12/p12_asn.o \
		  crypto/pkcs12/p12_attr.o \
		  crypto/pkcs12/p12_crpt.o \
		  crypto/pkcs12/p12_crt.o \
		  crypto/pkcs12/p12_decr.o \
		  crypto/pkcs12/p12_init.o \
		  crypto/pkcs12/p12_key.o \
		  crypto/pkcs12/p12_kiss.o \
		  crypto/pkcs12/p12_mutl.o \
		  crypto/pkcs12/p12_npas.o \
		  crypto/pkcs12/p12_p8d.o \
		  crypto/pkcs12/p12_p8e.o \
		  crypto/pkcs12/p12_sbag.o \
		  crypto/pkcs12/p12_utl.o \
		  crypto/pkcs12/pk12err.o \
		  crypto/pkcs7/bio_pk7.o \
		  crypto/pkcs7/pk7_asn1.o \
		  crypto/pkcs7/pk7_attr.o \
		  crypto/pkcs7/pk7_doit.o \
		  crypto/pkcs7/pk7_lib.o \
		  crypto/pkcs7/pk7_mime.o \
		  crypto/pkcs7/pk7_smime.o \
		  crypto/pkcs7/pkcs7err.o \
		  crypto/rand/md_rand.o \
		  crypto/rand/rand_egd.o \
		  crypto/rand/rand_err.o \
		  crypto/rand/rand_lib.o \
		  crypto/rand/rand_unix.o \
		  crypto/rand/rand_vms.o \
		  crypto/rand/rand_win.o \
		  crypto/rand/randfile.o \
		  crypto/rc4/rc4_enc.o \
		  crypto/rc4/rc4_skey.o \
		  crypto/rsa/rsa_ameth.o \
		  crypto/rsa/rsa_asn1.o \
		  crypto/rsa/rsa_chk.o \
		  crypto/rsa/rsa_crpt.o \
		  crypto/rsa/rsa_depr.o \
		  crypto/rsa/rsa_err.o \
		  crypto/rsa/rsa_gen.o \
		  crypto/rsa/rsa_lib.o \
		  crypto/rsa/rsa_meth.o \
		  crypto/rsa/rsa_none.o \
		  crypto/rsa/rsa_null.o \
		  crypto/rsa/rsa_oaep.o \
		  crypto/rsa/rsa_ossl.o \
		  crypto/rsa/rsa_pk1.o \
		  crypto/rsa/rsa_pmeth.o \
		  crypto/rsa/rsa_prn.o \
		  crypto/rsa/rsa_pss.o \
		  crypto/rsa/rsa_saos.o \
		  crypto/rsa/rsa_sign.o \
		  crypto/rsa/rsa_ssl.o \
		  crypto/rsa/rsa_x931.o \
		  crypto/rsa/rsa_x931g.o \
		  crypto/sha/sha1_one.o \
		  crypto/sha/sha1dgst.o \
		  crypto/sha/sha256.o \
		  crypto/sha/sha512.o \
		  crypto/stack/stack.o \
		  crypto/threads_none.o \
		  crypto/threads_pthread.o \
		  crypto/threads_win.o \
		  crypto/txt_db/txt_db.o \
		  crypto/uid.o \
		  crypto/x509/by_dir.o \
		  crypto/x509/by_file.o \
		  crypto/x509/t_crl.o \
		  crypto/x509/t_req.o \
		  crypto/x509/t_x509.o \
		  crypto/x509/x509_att.o \
		  crypto/x509/x509_cmp.o \
		  crypto/x509/x509_d2.o \
		  crypto/x509/x509_def.o \
		  crypto/x509/x509_err.o \
		  crypto/x509/x509_ext.o \
		  crypto/x509/x509_lu.o \
		  crypto/x509/x509_obj.o \
		  crypto/x509/x509_r2x.o \
		  crypto/x509/x509_req.o \
		  crypto/x509/x509_set.o \
		  crypto/x509/x509_trs.o \
		  crypto/x509/x509_txt.o \
		  crypto/x509/x509_v3.o \
		  crypto/x509/x509_vfy.o \
		  crypto/x509/x509_vpm.o \
		  crypto/x509/x509cset.o \
		  crypto/x509/x509name.o \
		  crypto/x509/x509rset.o \
		  crypto/x509/x509spki.o \
		  crypto/x509/x509type.o \
		  crypto/x509/x_all.o \
		  crypto/x509/x_attrib.o \
		  crypto/x509/x_crl.o \
		  crypto/x509/x_exten.o \
		  crypto/x509/x_name.o \
		  crypto/x509/x_pubkey.o \
		  crypto/x509/x_req.o \
		  crypto/x509/x_x509.o \
		  crypto/x509/x_x509a.o \
		  crypto/x509v3/pcy_cache.o \
		  crypto/x509v3/pcy_data.o \
		  crypto/x509v3/pcy_lib.o \

=== debian/changelog ===
shim (15+1533136590.3beb971-7) unstable; urgency=medium

  [ Ansgar Burchardt ]
  * debian/control: Update Vcs-* fields

  [ Steve McIntyre ]
  * Backport needed crash fixes:
    + VLogError(): Avoid NULL pointer dereferences in (V)Sprint calls
    + Fix OBJ_create() to tolerate a NULL sn and ln
  * Build using gcc-7 to get better control of reproducibility during the
    lifetime of Buster.
  * Build in a dbx list to blacklist binaries that we know to not be
    secure. Build-depend on a new (bug-fixed) version of pesign to
    generate that list at build time, using a list of known bad hashes.
  * Initial list of known bad hashes is just my personal test binary.

 -- Steve McIntyre <93sam@debian.org>  Wed, 08 May 2019 02:05:01 +0100

shim (15+1533136590.3beb971-6) unstable; urgency=medium

  [ Steve McIntyre ]
  * Add Provides: and Breaks: to shim-helpers-$arch-signed to fix
    clashes with the old shim-signed package for fbx64.efi.signed and
    mmx64.efi.signed. Closes: #924619

  [ Helmut Grohne ]
  * Fix FTCBFS: Set CROSS_COMPILE. (Closes: #922152)

 -- Steve McIntyre <93sam@debian.org>  Sat, 23 Mar 2019 18:19:13 +0000

shim (15+1533136590.3beb971-5) unstable; urgency=medium

  [ Ansgar Burchardt ]
  * Correct maintainer address in signing template

  [ Steve McIntyre ]
  * Remove Rules-Requires-Root in the signing template. We manually install
    things owned by root. There might be better ways to do this, but this
    will do for now.

 -- Steve McIntyre <93sam@debian.org>  Tue, 12 Mar 2019 01:38:19 +0000

shim (15+1533136590.3beb971-4) unstable; urgency=medium

  [ Steve McIntyre ]
  * No-change sourceful upload to get rebuilds (and hence build logs) from
    the buildds. Hoping to get this version signed by Microsoft, so let's
    make our setup as clean as possible.

 -- Steve McIntyre <93sam@debian.org>  Sat, 09 Mar 2019 22:24:23 +0000

shim (15+1533136590.3beb971-3) unstable; urgency=medium

  [ Philipp Hahn ]
  * debian/rules: fixing permissions no longer required
  * debian/rules: Disable ephemeral key on Debian.
  * Rename binary package to 'shim-unsigned'
  * Add template for signing {mm,fb}$ARCH.efi. (Closes: #922228)

  [ Luca Boccassi ]
  * Override lintian error about template rules file.
  * Include /usr/share/dpkg/architecture.mk instead of shelling out.
  * Add uname.patch to avoid embedding the kernel architecture in the
    binary and to use a fixed string instead.

  [ Steve McIntyre ]
  * Change maintenance address to be the EFI team
  * Add me and vorlon to the Uploaders list
  * Rename the helper binary packages to shim-helpers-$arch.
  * Update the signing-template JSON metadata to match new practice:
    + Move all the data under a new top-level "packages" key
    + Add an empty "trusted_certs" key - the helper binaries do not do any
      further verification with an embedded key.

 -- Steve McIntyre <93sam@debian.org>  Fri, 08 Mar 2019 21:59:43 +0000

shim (15+1533136590.3beb971-2) unstable; urgency=medium

  * Update debian/watch.
  * Update VCS to point to salsa.
  * Fix debian/rules syntax for arm64 build.
  * Enable build for i386.
  * Ensure DEB_HOST_ARCH is set even if not present in the environment.
  * Update Standards-Version.
  * Update debian/copyright (drop reference to file no longer in source)

 -- Steve Langasek <vorlon@debian.org>  Mon, 11 Feb 2019 05:18:18 +0000

shim (15+1533136590.3beb971-1) unstable; urgency=medium

  * New upstream release.
    - debian/patches/second-stage-path: dropped; the default loader path now
      includes an arch suffix.
    - debian/patches/sbsigntool-no-pesign: dropped; no longer needed.
  * Drop remaining patches that were not being applied.
  * Sync packaging from Ubuntu:
    - debian/copyright: Update upstream source location.
    - debian/control: add a Build-Depends on libelf-dev.
    - Enable arm64 build.
    - debian/patches/fixup_git.patch: don't run git in clean; we're not
      really in a git tree.
    - debian/rules, debian/shim.install: use the upstream install target as
      intended, and move files to the target directory using dh_install.
    - define RELEASE and COMMIT_ID for the snapshot.
    - Set ENABLE_HTTPBOOT to enable the HTTP Boot feature.
    - Update dh_auto_build/dh_auto_clean/dh_auto_install for new upstream
      options: set MAKELEVEL.
    - Define an EFI_ARCH variable, and use that for paths to shim. This
      makes it possible to build a shim for other architectures than amd64.
    - Set EFIDIR=$distro for dh_auto_install; that will let files be installed
      in the "right" final directories, and makes boot.csv for us.
    - Set ENABLE_SHIM_CERT, to keep using ephemeral self-signed certs built
      at compile-time for MokManager and fallback.
    - Set ENABLE_SBSIGN, to use sbsign instead of pesign for signing fallback
      and MokManager.

 -- Steve Langasek <vorlon@debian.org>  Sat, 09 Feb 2019 07:23:19 +0000

=== debian/control ===
Source: shim
Section: admin
Priority: optional
Maintainer: Debian EFI team <debian-efi@lists.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>, Steve McIntyre <93sam@debian.org>
Standards-Version: 4.3.0
Build-Depends: debhelper (>= 9), gnu-efi (>= 3.0u), sbsigntool, openssl, libelf-dev, gcc-7, pesign (>= 0.112-5)
Vcs-Browser: https://salsa.debian.org/efi-team/shim
Vcs-Git: https://salsa.debian.org/efi-team/shim.git

Package: shim-unsigned
Architecture: amd64 arm64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: shim (<< 15+1533136590.3beb971-3~),
Replaces: shim (<< 15+1533136590.3beb971-3~),
Description: boot loader to chain-load signed boot loaders under Secure Boot
 This package provides a minimalist boot loader which allows verifying
 signatures of other UEFI binaries against either the Secure Boot DB/DBX or
 against a built-in signature database.  Its purpose is to allow a small,
 infrequently-changing binary to be signed by the UEFI CA, while allowing
 an OS distributor to revision their main bootloader independently of the CA.

Package: shim-helpers-amd64-signed-template
Architecture: amd64
Depends: ${misc:Depends},
Description: boot loader to chain-load signed boot loaders (signing template)
 This package contains template files for shim-helpers-amd64-signed.
 This is only needed for Secure Boot signing.

Package: shim-helpers-i386-signed-template
Architecture: i386
Depends: ${misc:Depends},
Description: boot loader to chain-load signed boot loaders (signing template)
 This package contains template files for shim-helpers-i386-signed.
 This is only needed for Secure Boot signing.

Package: shim-helpers-arm64-signed-template
Architecture: arm64
Depends: ${misc:Depends},
Description: boot loader to chain-load signed boot loaders (signing template)
 This package contains template files for shim-helpers-arm64-signed.
 This is only needed for Secure Boot signing.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Other vendors, add your certs here.  No sense in using
# dpkg-vendor --derives-from, because only Canonical-generated binaries will
# be signed with this key; so if you are building your own shim binary you
# should be building the other binaries also.
ifeq ($(shell dpkg-vendor --is ubuntu && echo yes),yes)
	cert=debian/canonical-uefi-ca.der
	distributor=ubuntu
COMMON_OPTIONS ?= ENABLE_SHIM_CERT=1 ENABLE_SBSIGN=1
else
	cert=debian/debian-uefi-ca.der
	distributor=debian
endif

DBX_LIST = dbx.esl
DBX_HASHES = debian/$(distributor)-dbx.hashes

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH),amd64)
export EFI_ARCH := x64
endif
ifeq ($(DEB_HOST_ARCH),arm64)
export EFI_ARCH := aa64
endif
ifeq ($(DEB_HOST_ARCH),i386)
export EFI_ARCH := ia32
endif

COMMON_OPTIONS += \
	RELEASE=15 \
	COMMIT_ID=3beb971b10659cf78144ddc5eeea83501384440c \
	MAKELEVEL=0 \
	EFI_PATH=/usr/lib \
	ENABLE_HTTPBOOT=true \
	VENDOR_CERT_FILE=$(cert) \
	VENDOR_DBX_FILE=$(DBX_LIST) \
	EFIDIR=$(distributor) \
	CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)- \
	CC=$(DEB_HOST_GNU_TYPE)-gcc-7 \
	$(NULL)

$(DBX_LIST): $(DBX_HASHES)
	rm -f $@
	set -e; \
	for HASH in $$(grep -E [[:xdigit:]]{32} $<); do \
            echo efisiglist -o $@ -a -h $$HASH; \
            efisiglist -o $@ -a -h $$HASH; \
        done
	# Support an empty $(DBX_HASHES)
	touch $@

%:
	dh $@ --parallel

override_dh_auto_clean:
	dh_auto_clean -- MAKELEVEL=0
	rm -f $(DBX_LIST)

override_dh_auto_build: $(DBX_LIST)
	dh_auto_build -- $(COMMON_OPTIONS)

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp -- $(COMMON_OPTIONS)
	./debian/signing-template.generate

## shim 15+1552672080.a4a1fbe

=== Makefile ===
default : all

NAME		= shim
VERSION		= 15
ifneq ($(origin RELEASE),undefined)
DASHRELEASE	?= -$(RELEASE)
else
DASHRELEASE	?=
endif

ifeq ($(MAKELEVEL),0)
TOPDIR		?= $(shell pwd)
endif
ifeq ($(TOPDIR),)
override TOPDIR := $(shell pwd)
endif
override TOPDIR	:= $(abspath $(TOPDIR))
VPATH		= $(TOPDIR)

include $(TOPDIR)/Make.defaults
include $(TOPDIR)/Make.rules
include $(TOPDIR)/Make.coverity
include $(TOPDIR)/Make.scan-build

TARGETS	= $(SHIMNAME)
TARGETS += $(SHIMNAME).debug $(MMNAME).debug $(FBNAME).debug
ifneq ($(origin ENABLE_SHIM_HASH),undefined)
TARGETS += $(SHIMHASHNAME)
endif
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
TARGETS	+= $(MMNAME).signed $(FBNAME).signed
CFLAGS += -DENABLE_SHIM_CERT
else
TARGETS += $(MMNAME) $(FBNAME)
endif
OBJS	= shim.o mok.o netboot.o cert.o replacements.o tpm.o version.o errlog.o
KEYS	= shim_cert.h ocsp.* ca.* shim.crt shim.csr shim.p12 shim.pem shim.key shim.cer
ORIG_SOURCES	= shim.c mok.c netboot.c replacements.c tpm.c errlog.c shim.h version.h $(wildcard include/*.h)
MOK_OBJS = MokManager.o PasswordCrypt.o crypt_blowfish.o
ORIG_MOK_SOURCES = MokManager.c PasswordCrypt.c crypt_blowfish.c shim.h $(wildcard include/*.h)
FALLBACK_OBJS = fallback.o tpm.o errlog.o
ORIG_FALLBACK_SRCS = fallback.c

ifneq ($(origin ENABLE_HTTPBOOT), undefined)
	OBJS += httpboot.o
	SOURCES += httpboot.c include/httpboot.h
endif

SOURCES = $(foreach source,$(ORIG_SOURCES),$(TOPDIR)/$(source)) version.c
MOK_SOURCES = $(foreach source,$(ORIG_MOK_SOURCES),$(TOPDIR)/$(source))
FALLBACK_SRCS = $(foreach source,$(ORIG_FALLBACK_SRCS),$(TOPDIR)/$(source))

all: $(TARGETS)

shim.crt:
	$(TOPDIR)/make-certs shim shim@xn--u4h.net all codesign 1.3.6.1.4.1.311.10.3.1 </dev/null

shim.cer: shim.crt
	$(OPENSSL) x509 -outform der -in $< -out $@

.NOTPARALLEL: shim_cert.h
shim_cert.h: shim.cer
	echo "static UINT8 shim_cert[] __attribute__((__unused__)) = {" > $@
	$(HEXDUMP) -v -e '1/1 "0x%02x, "' $< >> $@
	echo "};" >> $@

version.c : $(TOPDIR)/version.c.in
	sed	-e "s,@@VERSION@@,$(VERSION)," \
		-e "s,@@UNAME@@,$(shell uname -s -m -p -i -o)," \
		-e "s,@@COMMIT@@,$(COMMIT_ID)," \
		< $< > $@

certdb/secmod.db: shim.crt
	-mkdir certdb
	$(PK12UTIL) -d certdb/ -i shim.p12 -W "" -K ""
	$(CERTUTIL) -d certdb/ -A -i shim.crt -n shim -t u

shim.o: $(SOURCES)
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
shim.o: shim_cert.h
endif
shim.o: $(wildcard $(TOPDIR)/*.h)

cert.o : $(TOPDIR)/cert.S
	$(CC) $(CFLAGS) -c -o $@ $<

$(SHIMNAME) : $(SHIMSONAME)
$(MMNAME) : $(MMSONAME)
$(FBNAME) : $(FBSONAME)

$(SHIMSONAME): $(OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)

fallback.o: $(FALLBACK_SRCS)

$(FBSONAME): $(FALLBACK_OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS)

MokManager.o: $(MOK_SOURCES)

$(MMSONAME): $(MOK_OBJS) Cryptlib/libcryptlib.a Cryptlib/OpenSSL/libopenssl.a lib/lib.a
	$(LD) -o $@ $(LDFLAGS) $^ $(EFI_LIBS) lib/lib.a

Cryptlib/libcryptlib.a:
	for i in Hash Hmac Cipher Rand Pk Pem SysCall; do mkdir -p Cryptlib/$$i; done
	$(MAKE) VPATH=$(TOPDIR)/Cryptlib TOPDIR=$(TOPDIR)/Cryptlib -C Cryptlib -f $(TOPDIR)/Cryptlib/Makefile

Cryptlib/OpenSSL/libopenssl.a:
	for i in x509v3 x509 txt_db stack sha rsa rc4 rand pkcs7 pkcs12 pem ocsp objects modes md5 lhash kdf hmac evp err dso dh conf comp cmac buffer bn bio async/arch asn1 aes; do mkdir -p Cryptlib/OpenSSL/crypto/$$i; done
	$(MAKE) VPATH=$(TOPDIR)/Cryptlib/OpenSSL TOPDIR=$(TOPDIR)/Cryptlib/OpenSSL -C Cryptlib/OpenSSL -f $(TOPDIR)/Cryptlib/OpenSSL/Makefile

lib/lib.a: | $(TOPDIR)/lib/Makefile $(wildcard $(TOPDIR)/include/*.[ch])
	if [ ! -d lib ]; then mkdir lib ; fi
	$(MAKE) VPATH=$(TOPDIR)/lib TOPDIR=$(TOPDIR) CFLAGS="$(CFLAGS)" -C lib -f $(TOPDIR)/lib/Makefile lib.a

buildid : $(TOPDIR)/buildid.c
	$(CC) -Og -g3 -Wall -Werror -Wextra -o $@ $< -lelf

$(BOOTCSVNAME) :
	@echo Making $@
	@echo "$(SHIMNAME),$(OSLABEL),,This is the boot entry for $(OSLABEL)" | iconv -t UCS-2LE > $@

install-check :
ifeq ($(origin LIBDIR),undefined)
	$(error Architecture $(ARCH) is not a supported build target.)
endif
ifeq ($(origin EFIDIR),undefined)
	$(error EFIDIR must be set to your reserved EFI System Partition subdirectory name)
endif

install-deps : $(TARGETS)
install-deps : $(SHIMNAME).debug $(MMNAME).debug $(FBNAME).debug buildid
install-deps : $(BOOTCSVNAME)

install-debugsource : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)
	find $(TOPDIR) -type f -a '(' -iname '*.c' -o -iname '*.h' -o -iname '*.S' ')' | while read file ; do \
		outfile=$$(echo $${file} | sed -e "s,^$(TOPDIR),,") ; \
		$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)/$$(dirname $${outfile}) ; \
		$(INSTALL) -m 0644 $${file} $(DESTDIR)/$(DEBUGSOURCE)/$(PKGNAME)-$(VERSION)$(DASHRELEASE)/$${outfile} ; \
	done

install-debuginfo : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGINFO)$(TARGETDIR)/
	@./buildid $(wildcard *.efi.debug) | while read file buildid ; do \
		first=$$(echo $${buildid} | cut -b -2) ; \
		rest=$$(echo $${buildid} | cut -b 3-) ; \
		$(INSTALL) -d -m 0755 $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/ ;\
		$(INSTALL) -m 0644 $${file} $(DESTDIR)/$(DEBUGINFO)$(TARGETDIR) ; \
		ln -s ../../../../..$(DEBUGINFO)$(TARGETDIR)$${file} $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/$${rest}.debug ;\
		ln -s ../../../.build-id/$${first}/$${rest} $(DESTDIR)/$(DEBUGINFO).build-id/$${first}/$${rest} ;\
	done

install : | install-check
install : install-deps install-debuginfo install-debugsource
	$(INSTALL) -d -m 0755 $(DESTDIR)/
	$(INSTALL) -d -m 0700 $(DESTDIR)/$(ESPROOTDIR)
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(EFIBOOTDIR)
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(TARGETDIR)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(EFIBOOTDIR)/$(BOOTEFINAME)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(TARGETDIR)/
	$(INSTALL) -m 0644 $(BOOTCSVNAME) $(DESTDIR)/$(TARGETDIR)/
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
	$(INSTALL) -m 0644 $(FBNAME).signed $(DESTDIR)/$(EFIBOOTDIR)/$(FBNAME)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(EFIBOOTDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(TARGETDIR)/$(MMNAME)
else
	$(INSTALL) -m 0644 $(FBNAME) $(DESTDIR)/$(EFIBOOTDIR)/
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(EFIBOOTDIR)/
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(TARGETDIR)/
endif

install-as-data : install-deps
	$(INSTALL) -d -m 0755 $(DESTDIR)/$(DATATARGETDIR)
	$(INSTALL) -m 0644 $(SHIMNAME) $(DESTDIR)/$(DATATARGETDIR)/
ifneq ($(origin ENABLE_SHIM_HASH),undefined)
	$(INSTALL) -m 0644 $(SHIMHASHNAME) $(DESTDIR)/$(DATATARGETDIR)/
endif
ifneq ($(origin ENABLE_SHIM_CERT),undefined)
	$(INSTALL) -m 0644 $(MMNAME).signed $(DESTDIR)/$(DATATARGETDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(FBNAME).signed $(DESTDIR)/$(DATATARGETDIR)/$(FBNAME)
else
	$(INSTALL) -m 0644 $(MMNAME) $(DESTDIR)/$(DATATARGETDIR)/$(MMNAME)
	$(INSTALL) -m 0644 $(FBNAME) $(DESTDIR)/$(DATATARGETDIR)/$(FBNAME)
endif

%.efi: %.so
ifneq ($(OBJCOPY_GTE224),1)
	$(error objcopy >= 2.24 is required)
endif
	$(OBJCOPY) -D -j .text -j .sdata -j .data -j .data.ident \
		-j .dynamic -j .dynsym -j .rel* \
		-j .rela* -j .reloc -j .eh_frame \
		-j .vendor_cert \
		$(FORMAT) $^ $@
	# I am tired of wasting my time fighting binutils timestamp code.
	dd conv=notrunc bs=1 count=4 seek=$(TIMESTAMP_LOCATION) if=/dev/zero of=$@

ifneq ($(origin ENABLE_SHIM_HASH),undefined)
%.hash : %.efi
	$(PESIGN) -i $< -P -h > $@
endif

%.efi.debug : %.so
ifneq ($(OBJCOPY_GTE224),1)
	$(error objcopy >= 2.24 is required)
endif
	$(OBJCOPY) -D -j .text -j .sdata -j .data \
		-j .dynamic -j .dynsym -j .rel* \
		-j .rela* -j .reloc -j .eh_frame \
		-j .debug_info -j .debug_abbrev -j .debug_aranges \
		-j .debug_line -j .debug_str -j .debug_ranges \
		-j .note.gnu.build-id \
		$^ $@

ifneq ($(origin ENABLE_SBSIGN),undefined)
%.efi.signed: %.efi shim.key shim.crt
	$(SBSIGN) --key shim.key --cert shim.crt --output $@ $<
else
%.efi.signed: %.efi certdb/secmod.db
	$(PESIGN) -n certdb -i $< -c "shim" -s -o $@ -f
endif

clean-shim-objs:
	$(MAKE) -C lib -f $(TOPDIR)/lib/Makefile clean
	@rm -rvf $(TARGET) *.o $(SHIM_OBJS) $(MOK_OBJS) $(FALLBACK_OBJS) $(KEYS) certdb $(BOOTCSVNAME)
	@rm -vf *.debug *.so *.efi *.efi.* *.tar.* version.c buildid
	@rm -vf Cryptlib/*.[oa] Cryptlib/*/*.[oa]
	@if [ -d .git ] ; then git clean -f -d -e 'Cryptlib/OpenSSL/*'; fi

clean: clean-shim-objs
	$(MAKE) -C Cryptlib -f $(TOPDIR)/Cryptlib/Makefile clean
	$(MAKE) -C Cryptlib/OpenSSL -f $(TOPDIR)/Cryptlib/OpenSSL/Makefile clean

GITTAG = $(VERSION)

test-archive:
	@rm -rf /tmp/shim-$(VERSION) /tmp/shim-$(VERSION)-tmp
	@mkdir -p /tmp/shim-$(VERSION)-tmp
	@git archive --format=tar $(shell git branch | awk '/^*/ { print $$2 }') | ( cd /tmp/shim-$(VERSION)-tmp/ ; tar x )
	@git diff | ( cd /tmp/shim-$(VERSION)-tmp/ ; patch -s -p1 -b -z .gitdiff )
	@mv /tmp/shim-$(VERSION)-tmp/ /tmp/shim-$(VERSION)/
	@git log -1 --pretty=format:%H > /tmp/shim-$(VERSION)/commit
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/shim-$(VERSION).tar.bz2 shim-$(VERSION)
	@rm -rf /tmp/shim-$(VERSION)
	@echo "The archive is in shim-$(VERSION).tar.bz2"

tag:
	git tag --sign $(GITTAG) refs/heads/master
	git tag -f latest-release $(GITTAG)

archive: tag
	@rm -rf /tmp/shim-$(VERSION) /tmp/shim-$(VERSION)-tmp
	@mkdir -p /tmp/shim-$(VERSION)-tmp
	@git archive --format=tar $(GITTAG) | ( cd /tmp/shim-$(VERSION)-tmp/ ; tar x )
	@mv /tmp/shim-$(VERSION)-tmp/ /tmp/shim-$(VERSION)/
	@git log -1 --pretty=format:%H > /tmp/shim-$(VERSION)/commit
	@dir=$$PWD; cd /tmp; tar -c --bzip2 -f $$dir/shim-$(VERSION).tar.bz2 shim-$(VERSION)
	@rm -rf /tmp/shim-$(VERSION)
	@echo "The archive is in shim-$(VERSION).tar.bz2"

.PHONY : install-deps shim.key

export ARCH CC LD OBJCOPY EFI_INCLUDE

=== Cryptlib/Makefile ===

EFI_INCLUDES	= -I$(TOPDIR)/Include -I$(EFI_INCLUDE) -I$(EFI_INCLUDE)/$(ARCH) -I$(EFI_INCLUDE)/protocol

CFLAGS		= -ggdb -O0 -I$(TOPDIR) -iquote $(TOPDIR) -fno-stack-protector -fno-strict-aliasing -fpic -fshort-wchar \
		  -Wall $(EFI_INCLUDES) -std=gnu89 \
		  -ffreestanding -I$(shell $(CC) -print-file-name=include)

CLANG_BUGS	= $(if $(findstring gcc,$(CC)),-maccumulate-outgoing-args,)

ifeq ($(ARCH),x86_64)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc $(CLANG_BUGS) \
		   -m64 -DEFI_FUNCTION_WRAPPER -DGNU_EFI_USE_MS_ABI \
		   -DNO_BUILTIN_VA_FUNCS -DMDE_CPU_X64
endif
ifeq ($(ARCH),ia32)
	CFLAGS	+= -mno-mmx -mno-sse -mno-red-zone -nostdinc \
		   $(CLANG_BUGS) -m32 -DMDE_CPU_IA32
endif
ifeq ($(ARCH),aarch64)
	CFLAGS	+= -DMDE_CPU_AARCH64
endif
ifeq ($(ARCH),arm)
	CFLAGS	+= -DMDE_CPU_ARM
endif
LDFLAGS		= -nostdlib -znocombreloc

TARGET		= libcryptlib.a
OBJS		=   Hash/CryptMd4Null.o \
		    Hash/CryptMd5.o \
		    Hash/CryptSha1.o \
		    Hash/CryptSha256.o \
		    Hash/CryptSha512.o \
		    Hmac/CryptHmacMd5Null.o \
		    Hmac/CryptHmacSha1Null.o \
		    Hmac/CryptHmacSha256Null.o \
		    Cipher/CryptAesNull.o \
		    Cipher/CryptTdesNull.o \
		    Cipher/CryptArc4Null.o \
		    Rand/CryptRand.o \
		    Pk/CryptRsaBasic.o \
		    Pk/CryptRsaExtNull.o \
		    Pk/CryptPkcs7SignNull.o \
		    Pk/CryptPkcs7Verify.o \
		    Pk/CryptDhNull.o \
		    Pk/CryptTs.o \
		    Pk/CryptX509.o \
		    Pk/CryptAuthenticode.o \
		    Pem/CryptPemNull.o \
		    SysCall/CrtWrapper.o \
		    SysCall/TimerWrapper.o \
		    SysCall/BaseMemAllocation.o \
		    SysCall/BaseStrings.o \
		    SysCall/memset.o

all: $(TARGET)

libcryptlib.a: $(OBJS)
	ar rcs libcryptlib.a $(OBJS)
clean:
	rm -f $(TARGET) $(OBJS)

=== debian/changelog ===
shim (15+1552672080.a4a1fbe-0ubuntu2) focal; urgency=medium

  * d/patches/fix-path-checks.patch: Cherry-pick upstream fix for regression
    in loading fwupd, or anything else specified as an argument (LP: #1864223)

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 20 Mar 2020 16:19:14 +0100

shim (15+1552672080.a4a1fbe-0ubuntu1) eoan; urgency=medium

  * New upstream snapshot 15+1552672080.a4a1fbe.
  * debian/patches/VLogError-Avoid-NULL-pointer-dereferences-in-V-Sprin.patch,
    debian/patches/fixup_git.patch: drop patches included in upstream.
  * debian/patches/MokManager-avoid-unaligned.patch: Fix compilation with GCC9:
    avoid -Werror=address-of-packed-member errors in MokManager.
  * debian/patches/tpm-correctness-1.patch,
    debian/patches/tpm-correctness-2.patch: fix issues in TPM calls to ensure
    the measurements are consistent with what is entered in the TPM event log.
  * debian/patches/tpm-correctness-3.patch: Don't log duplicate identical
    TPM events.
  * debian/patches/MokManager-hidpi-support.patch: Do a little bit more to
    try to get a more usable screen resolution for MokManager when running on
    HiDPI screens; by trying to detect such cases and switching to mode 0.
  * debian/rules: update COMMIT_ID explicitly for this new snapshot.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 11 Oct 2019 16:32:32 -0400

shim (15+1533136590.3beb971-0ubuntu2) eoan; urgency=medium

  * debian/copyright: Update upstream source location.
  * d/p/VLogError-Avoid-NULL-pointer-dereferences-in-V-Sprin.patch: Fix
    NULL pointer dereferences that lead to an exception error on arm64.
    (LP: #1811722)
  * d/p/Fix-OBJ_create-to-tolerate-a-NULL-sn-and-ln.patch: Fix NULL
    pointer dereference when calling OBJ_create() that leads to an
    exception error on arm64. (LP: #1811901)
  * debian/rules: Fix syntax of else statement when setting EFI_ARCH.

 -- dann frazier <dannf@ubuntu.com>  Tue, 30 Apr 2019 12:45:02 -0600

shim (15+1533136590.3beb971-0ubuntu1) cosmic; urgency=medium

  [ Steve Langasek ]
  * Fix Vcs link.

  [ dann frazier ]
  * Enable arm64 build.

  [ Mathieu Trudel-Lapierre ]
  * New upstream snapshot.
  * debian/patches/abort_abort_abort.patch: dropped patch, included upstream.
  * debian/rules:
    - define RELEASE and COMMIT_ID for the snapshot.
    - Set ENABLE_HTTPBOOT to enable the HTTP Boot feature.
  * debian/patches/fixup_git.patch: don't run git in clean; we're not really
    in a git tree.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 22 Aug 2018 10:52:10 -0400

=== debian/rules ===
#!/usr/bin/make -f

# Other vendors, add your certs here.  No sense in using
# dpkg-vendor --derives-from, because only Canonical-generated binaries will
# be signed with this key; so if you are building your own shim binary you
# should be building the other binaries also.
ifeq ($(shell dpkg-vendor --is ubuntu && echo yes),yes)
	cert=debian/canonical-uefi-ca.der
	distributor=ubuntu
else
	cert=debian/debian-uefi-ca.der
	distributor=debian
endif

ifeq ($(DEB_HOST_ARCH),amd64)
export EFI_ARCH := x64
endif
ifeq ($(DEB_HOST_ARCH),arm64)
export EFI_ARCH := aa64
endif

COMMON_OPTIONS = \
	RELEASE=15 \
	COMMIT_ID=a4a1fbe728c9545fc5647129df0cf1593b953bec \
	MAKELEVEL=0 \
	EFI_PATH=/usr/lib \
	ENABLE_HTTPBOOT=true \
	ENABLE_SHIM_CERT=1 \
	ENABLE_SBSIGN=1 \
	VENDOR_CERT_FILE=$(cert) \
	EFIDIR=$(distributor) \
	$(NULL)

%:
	dh $@ --parallel

override_dh_auto_clean:
	dh_auto_clean -- MAKELEVEL=0

override_dh_auto_build:
	dh_auto_build -- $(COMMON_OPTIONS)

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp -- $(COMMON_OPTIONS)

override_dh_fixperms:
	dh_fixperms
	chmod a-x debian/shim/usr/lib/shim/shim$(EFI_ARCH).efi
